#include <LiquidCrystal_I2C.h>
#include <Wire.h> // these to give me acces to the libarys 

LiquidCrystal_I2C lcd(0x27, 16, 2); // sets up the LCD screen display 

int TrigPin = 3;
int EchoPin = 2;
int green_led = 13;
int yellow_led = 12;
int red_led = 11;
int button = 10;
int buttonstate1 = 0;
int i = 1;
int buzzer = 4; // All of these are to give each a pin item


void setup()
{
  lcd.init(); // initialize the lcd
  lcd.backlight();
  pinMode(TrigPin, OUTPUT);
  pinMode(EchoPin, INPUT);
  pinMode(green_led, OUTPUT);
  pinMode(yellow_led, OUTPUT);
   pinMode(red_led, OUTPUT);
  pinMode(buzzer, OUTPUT);
  pinMode(button, INPUT); // This tells the arduino board whats where and if its an output or input 
     lcd.setCursor(0,0); //this makes sure that when the lcd prints out it only shows on the top 
  Serial.begin (9600);
}

void loop()
{
  
  while (i == 1) //loop statement 
  {
 Get_distance(); //the main void to get the distance and display it on the lcd also the leds and the buzzer 
  
    buttonstate1 = digitalRead(button); // this is to get the state of the slideswitch 
    if (buttonstate1 == HIGH) // The logic gate pasword was cracked 
    {
      lcd.clear(); // this clears the lcd so it's not displaying the distance anymore 
      lcd.print("SYSTEM OFF"); //printsw out system off on the lcd 
         digitalWrite(red_led, LOW); 
     digitalWrite(green_led, LOW);
     digitalWrite(yellow_led, LOW); // this is just to make sure that the leds stay off 
     noTone(buzzer); //this is also meant to turn off the buzzer 
      i=2; // setting I to 2 ends the loop statment
    }
  }
  buttonstate1 = digitalRead(button); //if the slideswitch switches to low then it would restart the loop 
   if (buttonstate1 == LOW)
    {
      lcd.clear();
      i=1; //sets loop back on 
    }
   
}

void Get_distance() //the main void 
{
  long durationindigit, distanceincm;
 digitalWrite(TrigPin, LOW);  
  delayMicroseconds(2);
  digitalWrite(TrigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(TrigPin, LOW);
  durationindigit = pulseIn(EchoPin, HIGH);
  distanceincm = (durationindigit/5) / 29.1; // these are calculations to get the centimeters and also these are fuctions that find the distance 
  lcd.clear();
  lcd.print(distanceincm); //prints out the distance in centimeters 
   lcd.print(" Centimeters");
  if (distanceincm < 50 && distanceincm > 20) {
      digitalWrite(green_led, HIGH); // if the distance is below 50 and above 20 then the led turns on 
}
  else {
      digitalWrite(green_led,  LOW); // if not it turns off the led 
  }
  
  if (distanceincm < 20 && distanceincm > 5) {
    digitalWrite(yellow_led,  HIGH);// if the distance is below 20 and above 5 then it turns on 
}
  else {
    digitalWrite(yellow_led,LOW); // if else the led turns back off 
  }
  if (distanceincm  < 5) {
    digitalWrite(red_led, HIGH); // if the distance is below 5 then it turns on the red led and the buzzer to alert you if there is an intruder 
    tone(buzzer, 1000);
}
  else  {
    digitalWrite(red_led,LOW); // if else then it stays off 
    noTone(buzzer);
  }
  delay(1000); // this is to delay the lcd display so it dosen't keep turning off and back on 
  
}